# Output pattern: 50 capital "H" per test
#PAT="0x4848484848484848484848484848484848484848484848484848484848484848484848484848484848484848484848484848"
# Output pattern: 10 capital "H" per test
PAT="0x48484848484848484848"
N=-1

# blast output will go to named pipes (FIFOs) with this basename
FIFO=/tmp/fifo
# blast errors will go to named pipes (FIFOs) with this basename
FIFO_ERR=/tmp/fifo_err
# the most recent error lines will be in normal .log files with this basename
ERR=/tmp/err

# "lp0" "com1" "com2"
for i in "vid3" "hd1" "fd1" "lp0" "com1" "com2" \
"cp0" "cp1" "cp2" "cp3" "cp4" "cp5" "cp6" "cp7"
do
	if [ -f ${FIFO}$i -o -p ${FIFO}$i ]
	then
		rm ${FIFO}$i
	fi
	mkfifo ${FIFO}$i

	if [ -f ${FIFO_ERR}$i -o -p ${FIFO_ERR}$i ]
	then
		rm ${FIFO_ERR}$i
	fi
	mkfifo ${FIFO_ERR}$i
done

echo "Insert DOS format diskette in drive A: and press return"
read X
mount -t msdos /dev/fd0 /mnt/fd

echo "About to mount MSDOS format IDE harddrive. Press return to continue" 
read X
mount -t msdos /dev/hda1 /mnt/hd

# To screen (/dev/tty3)  (Press Ctl/Alt/3 to get there)
TAG=vid3
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
PIDvid3_ERR=$!
blast -n$N -Dc -P"${PAT}" -o /dev/tty3 >${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &
PIDvid3=$!

# To hard disk (/mnt/hd/hd1.out)
TAG=hd1
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Db -P"${PAT}" -o /mnt/hd/${TAG}.out >${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To floppy (/mnt/fd/fd1.out)
TAG=fd1
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Db -P"${PAT}" -o /mnt/fd/${TAG}.out >${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To printer (/dev/lp)
TAG=lp0
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
#WORKSblast -n$N -Dc -P"${PAT}" -o /dev/lp0 >${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &
blast -n$N -Dc -P${PAT} -o /dev/lp0 >${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To COM1 (/dev/ttyS0)
#TAG=com1
#svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
#blast -n$N -Dt -P"${PAT}" -o /dev/ttyS0 -b115200 \
#>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To COM2 (/dev/ttyS1)
#TAG=com2
#svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
#blast -n$N -Dt -P"${PAT}" -o /dev/ttyS1 -b115200 \
#>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 0 (/dev/ttyCP0)
TAG=cp0
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
PIDcp0_ERR=$!
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP0 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &
PIDcp0=$!

# To Classicboard port 1 (/dev/ttyCP1)
TAG=cp1
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP1 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 2 (/dev/ttyCP2)
TAG=cp2
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP2 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 3 (/dev/ttyCP3)
TAG=cp3
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP3 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 4 (/dev/ttyCP4)
TAG=cp4
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP4 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 5 (/dev/ttyCP5)
TAG=cp5
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP5 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 6 (/dev/ttyCP6)
TAG=cp6
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP6 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &

# To Classicboard port 7 (/dev/ttyCP7)
TAG=cp7
svfifo -n 50 -i ${FIFO_ERR}${TAG} -o ${ERR}${TAG}.log &
blast -n$N -Dt -P"${PAT}" -o /dev/ttyCP7 -b921600 \
>${FIFO}${TAG} 2>${FIFO_ERR}${TAG} &


disp \
-f ${FIFO}vid3 -x0 -y0  -t1 -T"Video    " \
-f ${FIFO}hd1  -x0 -y1  -t1 -T"Harddisk " \
-f ${FIFO}fd1  -x0 -y2  -t1 -T"Floppy   " \
-f ${FIFO}lp0  -x0 -y3  -t1 -T"Printer  " \
-f ${FIFO}com1 -x0 -y4  -t1 -T"COM1     " \
-f ${FIFO}com2 -x0 -y5  -t1 -T"COM2     " \
-f ${FIFO}cp0  -x0 -y6  -t1 -T"CP0      " \
-f ${FIFO}cp1  -x0 -y7  -t1 -T"CP1      " \
-f ${FIFO}cp2  -x0 -y8  -t1 -T"CP2      " \
-f ${FIFO}cp3  -x0 -y9  -t1 -T"CP3      " \
-f ${FIFO}cp4  -x0 -y10 -t1 -T"CP4      " \
-f ${FIFO}cp5  -x0 -y11 -t1 -T"CP5      " \
-f ${FIFO}cp6  -x0 -y12 -t1 -T"CP6      " \
-f ${FIFO}cp7  -x0 -y13 -t1 -T"CP7      "


echo "Unmounting IDE drive..."
umount /mnt/hd
echo "Unmounting floppy..."
sleep 3
umount /mnt/fd
echo "Done..."
